program boinctop;
{ by tux2me, 2004 }

uses 
	linux, crt, sysutils;

const
	rc = '.boinctoprc';
	boincfile = '/client_state.xml';

	projektC = 'project_name';
	benutzerC = 'user_name';
	teamC = 'team_name';
	creditsC = 'user_total_credit';
	hcreditsC = 'host_total_credit';
	acreditsC = 'user_expavg_credit';
	zeitC = 'current_cpu_time';
	prozentC = 'fraction_done';
	fzeitC = 'final_cpu_time';
	
	mfeld = 100;
	n = 100;

type
	konfigR = record
		boincdir : string;
		end;
	projektZ = ^projektR;
	prozessZ = ^prozessR;
	cacheZ = ^cacheR;
	prozessR = record
		zeit, prozent : longint;
		end;
	cacheR = record
		fzeit : longint;
		end;
	prozesseA = array[1..n] of prozessZ;
	cacheA = array[1..n] of cacheZ;
	projektR = record
		projekt, team, benutzer : string[100];
                credits, hcredits, acredits : integer;
                prozess : prozesseA;
		cache : cacheA;
		end;
	projekteA = array[1..n] of projektZ;

var
	p : projekteA;
	pfad : string;
	boincdir : string;
	taste : char;
	tests, testt : string;
	uptime : longint;
	i1800, i1800_, main, help : longint;
	scroll, mscroll : longint;
	cacheg : longint;								{ globale variable fr fid in leseP }

procedure initcP (var x : cacheA);
	var
		i : longint;
	begin
	for i := 1 to n do
		x[i] := nil;
	end;

procedure initprP (var x : prozesseA);
	var
		i : longint;
	begin
	for i := 1 to n do
		x[i] := nil;
	end;

function pfadF : string;
        var
                s1, s2 : string;
                i : longint;
                ii : longint;
        begin
        i := 1;
        ii := 0;
        s1 := '';
        s2 := fexpand (paramstr (1));
        while (i < length (s2) + 1) and (ii < 3) do
                begin
                s1 := s1 + s2[i];
                if s2[i] = '/' then
                        ii := ii + 1;
                i := i + 1;
                end;
        pfadF := s1;
        end;

procedure startP;
	var
		s : string;
		f : file of konfigR;
		e : konfigR;
	begin
	if not fileexists (pfad + rc) then
		begin
		clrscr;
		textcolor (15);
		write ('boincTop 0.5.15');
		textcolor (7);
		writeln (' by poink, 2006');
		writeln ('This is free software. Lizens: GPL');
		writeln ('      [main developer] Andre Klausnitzer');
		writeln ('      [works with]     Boinc 4.x');
		writeln ('                       setiathome');
		writeln ('                       climateprediction');
		writeln;
		writeln ('home directory is: ', pfad);
		repeat
			write (' - please tell me a valid boinc directory: ');
			readln (s);
			if not fileexists (s + boincfile) then
				writeln ('directory must be valid! maybe boinc isnt installed.');
		until fileexists (s + boincfile) = true;
		e.boincdir := s;
		assign (f, pfad + rc);
		rewrite (f);
		write (f, e);
		close (f);
		end;
	end;

function getboincdirF : string;
	var
		f : file of konfigR;
		e : konfigR;
	begin
	assign (f, pfad + rc);
	reset (f);
	read (f, e);
	close (f);
	getboincdirF := e.boincdir;
	end; 

function parsetagF (s : string) : string;
	var
		i, l : longint;
		t : string;
		b : boolean;
	begin
	b := false;
	t := '';
	l := length (s);
	i := 0;
	while i < l do
		begin
		if s[i] = '<' then
			begin
			b := true;
			i := i + 1;
			end;
		if (b = true) and (s[i] <> '>') then
			t := t + s[i];
		if s[i] = '>' then
			begin
			b := false;
			i := l;
			end;
		i := i + 1;
		end;
	parsetagF := t;
	end;

function parsevalueF (s : string) : string;
	var
		i, l : longint;
		t : string;
		b : boolean;
	begin
	b := false;
	t := '';
	l := length (s);
	i := 0;
	while i < l do
		begin
		if s[i] = '>' then
			begin
			b := true;
			i := i + 1;
			end;
		if (b = true) and (s[i] <> '<') then
			t := t + s[i];
		if (b = true) and (s[i] = '<') then
			begin
			b := false;
			i := l;
			end;
		i := i + 1;
		end;
	parsevalueF := t;
	end;

function punktschmeissF (s : string) : string;
	var
		l, i : longint;
		a : string;
		b : boolean;
	begin
	l := length (s);
	a := '';
	b := true;
	i := 1;
	while (i < l) and (b = true) do
		begin
		if s[i + 1] = '.' then
			b := false;
		a := a + s[i];
		i := i + 1;
		end;
	punktschmeissF := a;
	end;

function formattimeF (s : string) : string;
	var
		z, min, h, d : longint;
		s_, e : string;
	begin
	e := '';
	s_ := '';
	z := 0;
	min := 0;
	h := 0;
	z := strtoint (s);
	h := z div 3600;
	min := (z - 3600 * h) div 60;
	if h > 24 then
		begin
		d := h div 24;
		h := h - d * 24;
		e := inttostr (d) + ' d ' + inttostr (h) + ' h ' + inttostr (min) + ' min';
		end
	else
		e := inttostr (h) + ' h ' + inttostr (min) + ' min';
	formattimeF := e;
	end;

function formatprozentF (s : string) : string;
	var
		e : string;
	begin
	e := ' 0.00';
	if length (s) >= 4 then
		begin
		if s[3] <> '0' then
			e[1] := s[3];
		e[2] := s[4];
		e[4] := s[5];
		e[5] := s[6];
		if e[5] = 'e' then
			e[5] := ' ';
		end;
	formatprozentF := e;
	end;

function remainingF (z : string; p : string) : string;
	{ z = aktuelle Zeit der WU
     p = Fortschritt in Prozent der WU

	  berechnet "eta"
	}
	var
		e : string;
		p_ : string;
		p__ : longint;
	begin
	e := '0';
	p_ := '    ';
	if length (p) >= 6 then
		begin
		p_[1] := p[3];
		p_[2] := p[4];
		p_[3] := p[5];
		p_[4] := p[6];
		p__ := strtoint (p_);
		if p__ <> 0 then
			e := inttostr ((strtoint (z) * 100 div (p__ div 100)) - strtoint (z))
		else
			e := '0';
		end;
	remainingF := e;
	end;

procedure clearlineP (f, t : longint);
	{ lscht eine Zeile im Terminal
	}
	var
		i : longint;
	begin
	for i := f to t do
		begin
		textbackground (8);
		gotoxy (1,i);
		write ('                                                                                ');
		end;
	end;

procedure leseP;
	var
		i : longint;
		projekt, benutzer : string;
		team : string;
		hcredits, credits, acredits : string;
		host : string;
		pid : longint;
		tprozent_ : real;
		f : textfile;
		s, tp_, tp__ : string;
		fid, afid, av : longint;
		zeit, prozent, rzeit, fzeit, tzeit, trtime, tprozent, avgzeit : string;
		cache : array[1..mfeld] of string;
	begin
	for i := 1 to 12 do
		cache[i] := '                                                        ';
	clearlineP (1, 1);
	clearlineP (3, 3);
	clearlineP (6, 8);
	clearlineP (10, 23);
	afid := 0;
	trtime := '0';
	fid := 1;
	fzeit := '0';
	projekt := 'unknown';
	benutzer := 'unknown';
	hcredits := '0';
	credits := '0';
	team := 'unknown';
	zeit := '0';
	rzeit := '0';
	prozent := '0.0000';
	s := '';
	acredits := '0';
	pid := getpid;
	host := gethostname;
	tzeit := '0';
	tprozent := '0000';
	tprozent_ := 0;
	avgzeit := '0';
	
	if fileexists (boincdir + boincfile) then
		begin
		gotoxy (1, 12);
		assign (f, boincdir + boincfile);
		reset (f);
		while not eof (f) do
			begin
			readln (f, s);
			if parsetagF (s) = projektC then
				projekt := parsevalueF (s) else
			if parsetagF (s) = benutzerC then
				benutzer := parsevalueF (s) else
			if parsetagF (s) = teamC then
       	        	        team := parsevalueF (s) else
			if parsetagF (s) = creditsC then
       		                 credits := punktschmeissF (parsevalueF (s)) else
			if parsetagF (s) = hcreditsC then
	                        hcredits := punktschmeissF (parsevalueF (s)) else
			if parsetagF (s) = acreditsC then
       		                acredits := punktschmeissF (parsevalueF (s)) else
			if parsetagF (s) = zeitC then
	                        zeit := punktschmeissF (parsevalueF (s)) else
			if parsetagF (s) = prozentC then
				prozent := parsevalueF (s) else
			if parsetagF (s) = fzeitC then
				begin
				fzeit := formattimeF (punktschmeissF (parsevalueF (s)));
				tzeit := inttostr (strtoint (tzeit) + strtoint (punktschmeissF (parsevalueF (s))));
				if punktschmeissF (parsevalueF (s)) <> '0' then
					begin
					afid := afid + 1;
					if fid < 10 then
						cache[fid] := '   ' + inttostr (fid) + '                       ' + fzeit
					else
						cache[fid] := '   ' + inttostr (fid) + '                      ' + fzeit;
					end
				else
					begin
					cache[fid] := '   ' + inttostr (fid);
					end;
				fid := fid + 1;
				end;
			end;
		close (f);

		fid := fid - 1;
		gotoxy (46,8);
		write ('cwus:    ', inttostr (fid));
		if afid <= 0 then
			afid := 0;
		if fid < 1 then
			fid := 1;
		rzeit := remainingF (zeit, prozent);
		tzeit := inttostr (strtoint (tzeit) + strtoint (zeit));	
		avgzeit := inttostr ((strtoint (tzeit) + strtoint (rzeit)) div (afid + 1));
		if fid = 1 then
			avgzeit := inttostr (strtoint (rzeit) + strtoint (zeit));
		rzeit := formattimeF (remainingF (zeit, prozent));
		prozent := formatprozentF (prozent);
		tprozent_ := (afid / fid) * 100 + (strtofloat (prozent) / fid);
		if afid = fid then
		tprozent_ := 10000;
		tprozent := floattostr (tprozent_);
		if afid = fid then
			tprozent := '99.99';
		
		tp_ := '0000';
		if tprozent[3] = '.' then
			begin
			tp_[1] := tprozent[1];
			tp_[2] := tprozent[2];
			if length (tprozent) > 3 then
				tp_[3] := tprozent[4];
			if length (tprozent) > 4 then
				tp_[4] := tprozent[5];
			end
		else
			begin
			tp_[2] := tprozent[1];
			if length (tprozent) > 2 then
				tp_[3] := tprozent[3];
			if length (tprozent) > 3 then
				tp_[4] := tprozent[4];
			end;
		if tp_ = '0000' then
			tp_ := '9999';
		trtime := inttostr (strtoint (tzeit) div strtoint (tp_) * (10000 - strtoint (tp_)));
		tp__ := ' 0.00';
		if tp_[1] <> '0' then
			begin
			tp__[1] := tp_[1];
			tp__[2] := tp_[2];
			tp__[4] := tp_[3];
			tp__[5] := tp_[4];
			end
		else
			begin
			tp__[2] := tp_[2];
			tp__[4] := tp_[3];
			tp__[5] := tp_[4];
			end;
		gotoxy (46,6);
		write ('avgtime: ');
		textcolor (15);
		write (formattimeF (avgzeit));
		textcolor (7);
		gotoxy (8,12);
		write ('cache');
		textcolor (15);
		gotoxy (46,11);
                write (formattimeF (trtime));
		gotoxy (1,11);
		write ('       wus total');
		gotoxy (64,11);
		write (tp__);
		gotoxy (28,11);
		write (formattimeF (tzeit));
		textcolor (7);
		zeit := formattimeF (zeit);

		{ version }
		gotoxy (62,1);
		write (' boinctop 0.5.16 - ');
		
		gotoxy (46,7);
		write ('uptime:  ', formattimeF (inttostr (uptime)));
		gotoxy (1,1);
		writeln;
		writeln ('   boinctoppid: ', pid);
		writeln ('   project:     ', projekt);
		writeln ('   user:        ', benutzer);
		writeln ('   team:        ', team);
		  write ('   credits:     ');
		textcolor (15);
		write (credits);
		textcolor (7);
		writeln;
		  write ('   hostcredits: ');
		textcolor (15);
		write (hcredits);
		textcolor (7);
		writeln;
		  write ('   avgcredits:  ');
		textcolor (15);
	       	write (acredits);
	        writeln;
		textcolor (15);
		textbackground (2);
		  write ('   id  type                time              eta               %done            ');
		textbackground (8);
		textcolor (7);
		gotoxy (28,10);
		write (zeit);
		gotoxy (4,10);
		write ('    running wu');
		gotoxy (64,10);
		write (prozent);
		gotoxy (46,10);
		write (rzeit);
		gotoxy (1,1);
		  write (' - ', host, ': ');
		gotoxy (1, 12);
		mscroll := fid;
		av := mscroll - scroll;
		if av > 11 then
			av := 11;
		for i := scroll to scroll + av do
			writeln (cache[i]);
		gotoxy (8, 12);
		  write ('cache');
		gotoxy (17,1);
		end
	else
		begin
		clearlineP (1, 1);
		gotoxy (1,1);
		writeln (' - "', boincfile, '" not found, press "a": ');
		end;
	end;

procedure hilfeP;
	begin
	clearlineP (3, 24);
	gotoxy (1, 3);
	textcolor (15);
        textbackground (2);
          write ('       explanation                                                              ');
        textbackground (8);
        textcolor (7);
	gotoxy (1, 4);
	writeln ('   h   switch helpscreen');
	writeln ('   a   refresh wu screen');
	writeln ('   q   quit');
	writeln ('   s   scroll down cache list');
	writeln ('   w   scroll up cache list');
	writeln;
	writeln ('       resetting boinctop: remove ~/.boinctoprc and try again');
	gotoxy (17, 1);
	end;



procedure leseP2;
	var
		f : textfile;
	begin
	
	end;

procedure initpP;
	var
		i : longint;
	begin
	for i := 1 to n do
		p[i] := nil;
	end;

begin
initpP;
scroll := 1;
help := 0;
main := 1;
uptime := 1;
i1800 := 0;
i1800_ := 0;
taste := '';
pfad := pfadF;
startP;
boincdir := getboincdirF;

clrscr;
{ leseP2; }
cacheg := 0;
leseP;
repeat
	if ((i1800 = 60) or (taste = 'a')) and (main = 1) then
		begin
		leseP;
		i1800 := 0;
		taste := '';
		end;
	if taste = 'h' then
		begin
		if help = 0 then
			begin
			main := 0;
			help := 1;
			hilfeP;
			end
		else
			begin
			main := 1;
			help := 0;
			clearlineP (3, 24);
			leseP;
			end;
		taste := '';
		end;
	if taste = 's' then
		begin
		if main = 1 then
			begin
			scroll := scroll + 1;
			if scroll > mscroll - 11 then
				scroll := mscroll - 11
			else
				leseP;
			end;
		taste := '';
		end;
	if taste = 'w' then
		begin
		if main = 1 then
			begin
			scroll := scroll - 1;
			if scroll = 0 then
				scroll := 1
			else
				leseP;
			end;
		taste := '';
		end;
	taste := readkey;
until taste = 'q';
gotoxy (1,16 + cacheg);
writeln ('   boinctop: exit --> thanks for using boinctop ;-)');
end.
